player = class:new()

function player:init()
	self.x = 196
	self.y = 196
	self.act_x = self.x + 4
	self.act_y = self.y + 4
	self.speed = 128
	self.canShoot = true
	self.shootTimer = 0
	self.bullets = {}
	self.bulletSpeed = 256
	self.bulletDelay = 0.1
	self.mouse_x = 0
	self.mouse_y = 0
	self.bulletsShot = 0
end

function player:update(dt)
	self.mouse_x, self.mouse_y = love.mouse.getPosition()
	self.act_x = self.x + 4
	self.act_y = self.y + 4	

	if love.keyboard.isDown("w") then
		self.y = self.y - self.speed * dt
	elseif love.keyboard.isDown("s") then
		self.y = self.y + self.speed * dt
	end
	
	if love.keyboard.isDown("a") then
		self.x = self.x - self.speed * dt
	elseif love.keyboard.isDown("d") then
		self.x = self.x + self.speed * dt
	end
	
	if love.mouse.isDown("l") and self.canShoot == true then
		player:shoot()
	end
	
	if self.canShoot == false then
		self.shootTimer = self.shootTimer + dt
		if self.shootTimer >= self.bulletDelay then
			self.canShoot = true
			self.shootTimer = 0
		end
	end
	
	for i,bullet in ipairs(self.bullets) do
		bullet.x = bullet.x + math.cos(bullet.angle) * self.bulletSpeed * dt
		bullet.y = bullet.y + math.sin(bullet.angle) * self.bulletSpeed * dt	
	end
end

function player:draw()
	for i,bullet in ipairs(self.bullets) do
		love.graphics.setColor(0, 250, 120, 255)
		love.graphics.rectangle("fill", bullet.x, bullet.y, 2, 2)
	end
	
	love.graphics.setColor(150, 150, 150, 255)
	love.graphics.rectangle("fill", self.x, self.y, 8, 8)	
end

function player:shoot()
	self.bullets[#self.bullets + 1] = {
		x = self.act_x,
		y = self.act_y,
		angle = math.atan2(self.mouse_y - self.act_y, self.mouse_x - self.act_x)
	}
	
	self.bulletsShot = self.bulletsShot + 1
	self.canShoot = false
end