slider = class:new()

function slider:init()
	self.x = -16
	self.y = love.math.random(0, 396)
	self.act_x = self.x + 4
	self.act_y = self.y + 4
	self.speed = 64
	self.bullets = {}
	self.bulletSpeed = 256
	self.bulletDelay = 0
end

function slider:update(dt)
	self.x = self.x + self.speed * dt
	self.bulletDelay = self.bulletDelay + dt
	self.act_x = self.x + 4
	self.act_y = self.y + 4
	
	if self.x > 396 then
		self.speed = -64
	elseif self.x < 0 then
		self.speed = 64
	end
	
	for i,bullets in ipairs(self.bullets) do
		bullets.x = bullets.x + math.cos(bullets.angle) * self.bulletSpeed * dt
		bullets.y = bullets.y + math.sin(bullets.angle) * self.bulletSpeed * dt	
	end	
	
	if self.bulletDelay >= 1 then
		slider:shoot(player.act_x, player.act_y)
		self.bulletDelay = 0
	end
end

function slider:draw()
	for i,bullet in ipairs(self.bullets) do
		love.graphics.setColor(255, 0, 0, 255)
		love.graphics.rectangle("fill", bullet.x, bullet.y, 2, 2)
	end

	love.graphics.setColor(100, 100, 100, 255)
	love.graphics.rectangle("fill", self.x, self.y, 8, 8)
end

function slider:shoot(target_x, target_y)
	self.bullets[#self.bullets + 1] = {
		x = self.act_x,
		y = self.act_y,
		angle = math.atan2(target_y - self.act_y, target_x - self.act_x)
	}
end
